---
title: SpeechSynthesisEvent
slug: Web/API/SpeechSynthesisEvent
tags:
  - API
  - Experimental
  - Interface
  - Reference
  - SpeechSynthesisEvent
  - Web Speech API
  - speech
  - synthesis
---
<p>{{APIRef("Web Speech API")}}{{SeeCompatTable}}</p>

<p>The <strong><code>SpeechSynthesisEvent</code></strong> interface of the <a href="/en-US/docs/Web/API/Web_Speech_API">Web Speech API</a> contains information about the current state of {{domxref("SpeechSynthesisUtterance")}} objects that have been processed in the speech service.</p>

<h2 id="Properties">Properties</h2>

<p><em>The {{domxref("SpeechSynthesisEvent")}} interface also inherits properties from its parent interface, {{domxref("Event")}}.</em></p>

<dl>
	<dt>{{domxref("SpeechSynthesisEvent.charIndex")}} {{readonlyinline}}</dt>
	<dd>Returns the index position of the character in the {{domxref("SpeechSynthesisUtterance.text")}} that was being spoken when the event was triggered.</dd>
	<dt>{{domxref("SpeechSynthesisEvent.elapsedTime")}} {{readonlyinline}}</dt>
	<dd>Returns the elapsed time in milliseconds after the {{domxref("SpeechSynthesisUtterance.text")}} started being spoken that the event was triggered at.</dd>
	<dt>{{domxref("SpeechSynthesisEvent.name")}} {{readonlyinline}}</dt>
	<dd>Returns the name associated with certain types of events occuring as the {{domxref("SpeechSynthesisUtterance.text")}} is being spoken: the name of the <a href="http://www.w3.org/TR/speech-synthesis/#S3.3.2">SSML</a> marker reached in the case of a {{event("mark")}} event, or the type of boundary reached in the case of a {{event("boundary")}} event.</dd>
	<dt>{{domxref("SpeechSynthesisEvent.utterance")}} {{readonlyinline}}</dt>
	<dd>Returns the {{domxref("SpeechSynthesisUtterance")}} instance that the event was triggered on.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>The {{domxref("SpeechSynthesisEvent")}} interface also inherits methods from its parent interface, {{domxref("Event")}}.</em></p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js language-js">utterThis.onpause = function(event) {
  var char = event.utterance.text.charAt(event.charIndex);
  console.log('Speech paused at character ' + event.charIndex + ' of "' +
  event.utterance.text + '", which is "' + char + '".');
}

utterThis.onboundary = function(event) {
  console.log(event.name + ' boundary reached after ' + event.elapsedTime + ' milliseconds.');
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Web Speech API', '#speechsynthesisevent', 'SpeechSynthesisEvent')}}</td>
			<td>{{Spec2('Web Speech API')}}</td>
			<td> </td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SpeechSynthesisEvent")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/Web_Speech_API">Web Speech API</a></li>
</ul>
